CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver

PUB Main | touchtest  ' debug value
  tch.BeginProgram                                       ' display type 2 = dual ILI9325, false means run a program not the desktop so don't load icons
  Buttons
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB Buttons | ck1x,ck1y,ck1s,ck2x,ck2y,ck2s,rd1x,rd1y,rd1s,rd2x,rd2y,rd2s,rd3x,rd3y,rd3s,bu1x,bu1y,xval,yval,redraw,f,f2,sx1,sy1,sx2,sy2 ' test out buttons, radio buttons, checkboxes 
   tch.SetOrientation(true)                             ' portrait view
   tch.ClearRam                                          ' file 0 and 1 reserved
   tch.Clearscreen(tch.RGBtoWord(212,208,200))          ' background gray color determined from paintshop
   Textbox(10,200,120,215)                              ' clear a text box. height = fontheight+1?
   f := tch.Loadfont(string("MSans14W.ifn"))            ' file 2 black on white font
   tch.setcurx(12)                                      ' x = x1+2 in textboxclear and see lorem for displaying text from an sd card
   tch.setcury(201)                                     ' y = y1 in textboxclear
   tch.TextT(f,string("This is a textbox"))             ' draw text for the textbox
   f2 := tch.Loadfont(string("MSans14.ifn"))            ' file 3 black on gray 14 point seems to be the same as 8.25 in vb.net ? why
   tch.SDBMPtoRam(string("butn8430.bmp"))               ' file 4 a button 84x30 in size
   tch.SDBMPtoRam(string("Uncheckd.bmp"))               ' file 5 unchecked checkbox pic3
   tch.SDBMPtoRam(string("Checked.bmp"))                ' file 6 checked checkbox pic4
   tch.SDBMPtoRam(string("RadioUnc.bmp"))               ' file 7 unchecked radiobox pic 5
   tch.SDBMPtoRam(string("RadioChk.bmp"))               ' file 8 checked radiobox pic 6
   tch.SDBMPtoRam(string("hot120.bmp"))                 ' file 9 picturebox demo
   tch.DrawBMPRam(9,115,10)                             ' draw file 9
   tch.stringdim(5)                                     ' file 9 is the strings
   tch.stringstore(0,string("Ok"))                      ' store string for the ok button
   redraw := true    
   ' set all the locations of the objects on the screen
   sx1:=130                                            ' select box (similar to a multiline text box)
   sy1:=160
   sx2:=230
   sy2:=260
   Selectbox(sx1,sy1,sx2,sy2)                       ' draw a multiline selectbox
   MoveVerticalScroll(sx2,sy1,sy2,0)                   ' scrollbar to item 0 (0-255)
   ck1x := ck2x := rd1x := rd2x := rd3x := 20           ' x all the same 
   ck1y := 10    
   ck2y := ck1y + 40                                    ' y coordinates
   rd1y := ck2y + 40
   rd2y := rd1y + 40
   rd3y := rd2y + 40
   bu1x := 80                                           ' button position
   bu1y := 280
   ck1s := true                                         ' startup status
   ck2s := false
   rd1s := true
   rd2s := false
   rd3s := false
   ' now wait for touch
   tch.SelectSPIGroup                                   ' talk to the spi touchscreen
   repeat
      if redraw                                         ' if redraw true then redraw all the objects
         tch.SelectMemGroup                             ' display mode
         DrawCheckbox(ck1x,ck1y,ck1s,string("Check1"),5,6,f2)        ' checkbox
         DrawCheckbox(ck2x,ck2y,ck2s,string("Check2"),5,6,f2)        ' checkbox
         DrawRadiobox(rd1x,rd1y,rd1s,string("Radiobutton1"),7,8,f2)     ' radiobox
         DrawRadiobox(rd2x,rd2y,rd2s,string("Radiobutton1"),7,8,f2)     ' radiobox 
         DrawRadiobox(rd3x,rd3y,rd3s,string("Radiobutton2"),7,8,f2)     ' radiobox
         DrawButton(bu1x,bu1y,0,4,f2)                         ' button (fixed size at the moment)
         redraw := false
         tch.SelectSPIGroup                             ' talk to the spi touchscreen  
      yval := tch.TouchYPercent                         ' decode yval 0-100%                
      xval := tch.TouchXPercent                         ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
        xval := (xval * 24) / 10                        ' scale to pixels as can measure from the picture in paintshop
        yval := (yval * 32) / 10                        ' scale to pixels
        if xval < 100
          case yval
            (ck1y-10)..(ck1y+25): !ck1s                   ' checkbox is small so active area bigger than the checkbox
                                  redraw := true          ' redraw the screen
            (ck2y-10)..(ck2y+25): !ck2s                   ' checkbox is small so active area bigger than the checkbox
                                  redraw := true         
            (rd1y-10)..(rd1y+25): rd1s :=   true            ' there probably is a smarter way to make one value true and all the rest false
                                  rd2s :=   false
                                  rd3s :=   false                   
                                  redraw := true
            (rd2y-10)..(rd2y+25): rd1s :=   false            
                                  rd2s :=   true
                                  rd3s :=   false                   
                                  redraw := true
            (rd3y-10)..(rd3y+25): rd1s :=   false            
                                  rd2s :=   false
                                  rd3s :=   true                  
                                  redraw := true
          tch.pause1ms(250)                               ' debounce 
                                     
        case yval
          bu1y..(bu1y + 30): return                     ' button so exit this screen

        if (xval > sx2 - 25) and (xval < sx2+10) and (yval > sy1) and (yval < sy2) ' slider knob
           tch.SelectMemGroup                             ' display mode
           MoveVerticalScroll(sx2,sy1,sy2,yval)      ' there is some maths based on sy1, sy2 and yval to work out a percentage  
           tch.SelectSPIGroup                             ' talk to the spi touchscreen

PUB TextBox(x1,y1,x2,y2)                           ' draw the outline of the box
    tch.ClearRectangle(x1,y1,x2,y2,tch.RGBtoWord(255,255,255))
    tch.Drawline(x1-1,y1-1,x2,y1-1,tch.RGBtoWord(64,64,64))        ' gray outline lines - extract values from paint shop pro
    tch.Drawline(x1-2,y1-2,x2+1,y1-2,tch.RGBtoWord(128,128,128))   ' horizontal upper light gray   
    tch.Drawline(x1-1,y1-1,x1-1,y2,tch.RGBtoWord(64,64,64))         ' vertical left gray
    tch.Drawline(x1-2,y1-2,x1-2,y2+1,tch.RGBtoWord(128,128,128))    ' vertical left light gray
    tch.Drawline(x2+2,y1-2,x2+2,y2+2,tch.RGBtoWord(255,255,255))    ' vertical right white
    tch.Drawline(x1-2,y2+2,x2+2,y2+2,tch.RGBtoWord(255,255,255))   ' horizontal lower white

PUB Selectbox(x1,y1,x2,y2)
   Textbox(x1,y1,x2,y2)
   VerticalScroll(x2,y1,y2)                             ' draw a vertical scroll bar

PUB VerticalScroll(x2,y1,y2)
   Arrowbox(x2-15,y1,15)                                   ' upper arrow box background
   Arrowbox(x2-15,y2-15,15)                                ' lower arrow box background
   UpArrow(x2,y1)                                          ' arrow
   DownArrow(x2,y2)                                        ' arrow

PUB MoveVerticalScroll(x2,y1,y2,yvalue)                    ' pass yvalue
   tch.Drawline(x2-15,y1+16,x2,y2-16,tch.RGBtoWord(237,232,228))   ' windows crosshatches 212,208,200 but we can send the exact gray which is simpler than crosshatching
   if yvalue < (y1+15)                                    ' upper range
     yvalue := y1+15
   if yvalue > (y2-15-11)                                    ' lower range 15 for arrow and slider height
     yvalue := y2-15-11                                   ' 15 for down arrow 10 for slider height
  Arrowbox(x2-15,yvalue,10)                               ' slider is 10 high
  

PUB DrawCheckbox(x,y,Checked,stringptr,c1,c2,f) | i                ' draw a checkbox x,y,checked, string, file for checked, file for unchecked, font file
   if checked
     tch.DrawBMPRam(c1,x,y) 
   else
     tch.DrawBMPRam(c2,x,y)  
   tch.setcurx(x+20)                                         ' add 20 width
   tch.setcury(y)
   tch.TextT(f,stringptr)

PUB DrawRadioBox(x,y,Checked,Stringptr,c1,c2,f)| i              ' draw a radio box
   if checked
     tch.DrawBMPRam(c1,x,y)
   else
     tch.DrawBMPRam(c2,x,y) 
   tch.setcurx(x+20)                                        ' add 20 width
   tch.setcury(y)
   tch.TextT(f,stringptr)
                                           
PUB DrawButton(x,y,stringn,c1,f)                  ' draw a radio box
   tch.DrawBMPRam(c1,x,y) 
   tch.setcurx(x + (84/2)-(tch.stringlen(stringn)*4 / 2))        ' centre, avg width 4 per char 84 could be a variable width passed to this routine
   tch.setcury(y + 8)
   tch.StringPrint(f,stringn)                               ' print

PUB UpArrow(x1,y1)
   tch.Drawline(x1-7,y1+6,x1-7,y1+6,0)                      ' black pixel
   tch.Drawline(x1-8,y1+7,x1-6,y1+7,0)                      ' lines
   tch.Drawline(x1-9,y1+8,x1-5,y1+8,0)                      ' lines
   tch.Drawline(x1-10,y1+9,x1-4,y1+9,0)                     ' lines

PUB DownArrow(x1,y1)
   tch.Drawline(x1-7,y1-6,x1-7,y1-6,0)                      ' black pixel
   tch.Drawline(x1-8,y1-7,x1-6,y1-7,0)                      ' lines
   tch.Drawline(x1-9,y1-8,x1-5,y1-8,0)                      ' lines
   tch.Drawline(x1-10,y1-9,x1-4,y1-9,0)                     ' lines     

PUB ArrowBox(x1,y1,h)                                   ' h is height
   tch.Drawline(x1,y1,x1+14,y1+h-1,tch.RGBtoWord(212,208,200))   ' gray upper arrow background
   tch.Drawline(x1+15,y1,x1+15,y1+h,tch.RGBtoWord(64,64,64))   ' vertical left gray   
   tch.Drawline(x1,y1+h,x1+15,y1+h,tch.RGBtoWord(64,64,64))   ' horizontal lower gray
   tch.Drawline(x1+1,y1+1,x1+13,y1+1,tch.RGBtoWord(255,255,255))' upper white line
   tch.Drawline(x1+1,y1+1,x1+1,y1+h-2,tch.RGBtoWord(255,255,255))' horizontal white line
   tch.Drawline(x1+1,y1+h-1,x1+14,y1+h-1,tch.RGBtoWord(128,128,128))' horizontal dark gray
   tch.Drawline(x1+14,y1+1,x1+14,y1+h-1,tch.RGBtoWord(128,128,128))' vertical gray