CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
OBJ
  tch:           "Touch"                                 ' touchscreen driver
PUB Main | wcboot  ' warm or cold boot                   ' 
  wcboot := tch.BeginDesktop("I")                            ' "I" = ILI9325, "S"= SSD1289
  if wcboot == false                                    ' erase ram chip, checks if a cold or warm boot, sets some variables
      'tch.Clearscreen(tch.RGBtoWord(0,0,0))            ' clear screen to black - uses the display driver above
      tch.SDBMPtoRam(string("desktop.bmp"))                    ' file number 1, a 240x320 file called desktop.bmp     
      DrawDesktop
      LoadDesktopCSV
      DrawIcons 
  else                                                          ' warm boot
      tch.ManualValues                                         ' coming from outside so reset ramsize and ramlocation values for 0 and 1
      DrawDesktop                                           ' quick redraw of desktop if a warm boot
      LoadDesktopCSV
      
  tch.SelectSPIGroup                                        ' selects this group and starts the cog
  Touchscreen                                           ' wait for input

PUB TouchScreen  | yval, xval,pointer
    repeat
      yval := tch.TouchYPercent                         ' decode yval 0-100%               
      xval := tch.TouchXPercent                         ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)
        pointer := (yval/20)*4+(xval/25)                ' reduce to a value 0-19 so can read the correct string for the file name
        if pointer < 20                                 ' there are spaces for 20 icons on the screen 4 wide 5 high
          tch.SelectMemGroup
        tch.StringJoin(85,pointer+60,81)                ' filename plus .exe
        ' tch.stringdebug(85)                           ' print out to test this
        tch.Clearscreen(tch.RGBtoWord(0,0,0))           ' so something happens straight away
        tch.Chain(tch.stringrambuffer(85))              ' run this filename


PUB DrawDesktop                  
   tch.DrawBMPRam(1,0,0)                                ' file number 1, location 0,0

PUB LoadDesktopCSV | n                                  ' load the file desktop.csv (Excel csv file with icon locations)
   tch.SDBMPtoRam(string("mask.bmp"))                   ' file 2, load this here - if load after the strings get a white line on the icons  
   tch.StringDim(85)                                    ' file number 3 is all the strings
   tch.StringStore(80,string("desktop.csv"))            ' filename to load
   tch.StringLoadfile(80,0)                             ' load from 0 to 19 (20 lines of text in a desktop.csv file)
   repeat n from 0 to 19
     CutupComma(n)
   tch.StringStore(81,string(".exe"))                   ' store exe extension for later  
   tch.StringStore(82,string(".bmp"))                   ' store .bmp extension
   tch.StringStore(83,string("blank"))                  ' store for later
   ' array 0-19 are raw string, 20-39 are x, 40-59 are y, 60-79 are filename with no extension or "blank"

PUB DrawIcons | n,x,y
   repeat n from 60 to 79                               ' draw the icons - mask alredy loaded in file 2 when loading desktop
     if tch.StringCompare(n,83) <> 0                    ' is this entry "blank"?
       tch.StringJoin(85,n,82)                          ' create filename.bmp
       x := tch.StringVal(n-40)                         ' need to pre-evaluate these, can't put in the mergebackground routine
       y := tch.StringVal(n-20)
       tch.MergeBackgroundIconRam(tch.stringrambuffer(85),x,y,1,2,4)   ' desktop file 1, mask file 2, icons in file 4
       DrawDesktop

PUB CutupComma(Source) | c1,c2,len                      ' pass source 0-19, dest = 20-39 for first group, 40-59 for second group etc
   c1 := tch.StringInstr(Source,1,",")                  ' first comma
   c2 := tch.StringInstr(Source,c1+1,",")               ' second comma
   len := tch.StringLen(Source)                         ' length
   tch.StringLeft(Source+20,Source,c1-1)                ' first value
   tch.StringMid(Source+40,Source,c1+1,c2-c1-1)         ' second value
   tch.StringRight(Source+60,Source,len-c2)             ' third value = filename with no extension

       