CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000

  _baudRate = 115200

  _receiverPin = 31 ' The boot loader uses pin 31 as its receiver pin.
  _transmitterPin = 30 ' The boot loader uses pin 30 as its transmitter pin.


OBJ

  serial: "Full-Duplex_COMEngine.spin"
  sd:   "SD-MMC_FATEngine.spin"

VAR
   byte packet[520]   ' big enough for a 512 byte packet plus the head and tail
   byte data[512]     ' data bytes 
  

PUB main | i 
  serial.COMEngineStart(_receiverPin, _transmitterPin, _baudRate) ' Never fails.
  serial.receiverFlush
  data[0] := 5
  repeat
    pause1ms(1000)
    serial.writebyte(13)
    createpacket(7,1)
    repeat i from 0 to 9
      printdecimal(packet[i])
      serial.writebyte(" ")


PUB CreatePacket(packettype,nbytes)             ' create packet array from data array
   ' 1 byte for start of file
   ' 1 byte for type of packet eg open a file, send data, close file
   ' 1 word for length of data
   ' n bytes for data
   ' 1 long for checksum
   ' 1 byte for end of file
   packet[0] := 1                                       ' ascii start of heading
   packet[1] := packettype                              ' type of packet
   bytemove(@packet+2,@nbytes,2)                        ' byte 2 and 3 are the number of bytes, lsb first
   'packet[2] := nbytes & $000000FF                      ' lsb of the number of bytes
   'packet[3] := nbytes >> 8                             ' msb of the number of bytes
   bytemove(@packet+4,@data,nbytes)                     ' copy the data to the packet array
   result := Checksum(nbytes)                           ' returns result
   bytemove(@packet+4+nbytes,@result,4)                 ' 4 bytes for the checksum
   packet[8+nbytes] := 4                                ' ascii  end of transmission

PUB Checksum(nbytes) | i ' returns checksum for the data array
   result := 0
   repeat i from 0 to nbytes-1
     result += data[i]

PUB pause1ms(period) | clkcycles
'' Pause execution for period (in units of 1 ms).
  clkcycles := ((clkfreq / 1000 * period) - 4296) #> 381     ' Calculate 1 ms time unit
  waitcnt(clkcycles + cnt)                                   ' Wait for designated time     

PUB printDecimal(integer) | temp[3] ' Writes a decimal string.

  if(integer < 0) ' Print sign.
    serial.writeByte("-")

  longfill(@temp, 0, 3)

  repeat result from 10 to 1 ' Convert number.
    temp.byte[result] := ((||(integer // 10)) + "0")
    integer /= 10

  result := @temp ' Skip past leading zeros.
  repeat ' Format saves two bytes.
  while(byte[++result] == "0")
  result += (not(byte[result]))

  serial.writeString(result~) ' Print number.     
        
    
 