CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver
VAR     long          DatabaseStart
        long          DatabaseFinish 

PUB Main | touchtest  ' debug value
  tch.BeginProgram                                       ' display type 2 = dual ILI9325, false means run a program not the desktop so don't load icons
  'Buttons
  'Bubblesort(1,6)                                   ' sort the list
  'tch.stringstore(0,string("Elephant"))                  ' search for this
  'touchtest := BinarySearch(1,6)                    ' do a binary search
  'tch.text(string("Found answer"))
  'tch.hex(touchtest,2) ' zero if no match
   StoreObjects



  repeat
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB BubbleSort(start,finish) | i,swap
   'tch.stringdim(10)                  ' uses string0 as a temp store
   'tch.stringstore(1,string("Bee"))
   'tch.stringstore(2,string("Cow"))
   'tch.stringstore(3,string("Dog"))
   'tch.stringstore(4,string("Aardvark"))
   'tch.stringstore(5,string("Elephant"))
   'tch.stringstore(6,string("Giraffe"))
   repeat
     swap := false
     repeat i from start to (finish-1)
       if tch.stringcompare(i,i+1) >0
         tch.stringcopy(0,i)                            ' swap
         tch.stringcopy(i,i+1)
         tch.stringcopy(i+1,0)
         swap := true
   until swap == false                                  ' repeat until no swaps happened
   'repeat i from start to finish                       ' print out the answers in alphabetical order
   '  tch.stringdebug(i)

PUB BinarySearch(start,finish) | imid, imin, imax,compare      ' http://en.wikipedia.org/wiki/Binary_search_algorithm
   imin := start   
   imax := finish                                      ' string(0) is the key to search
   compare := -1                                        ' if not found returns zero
   repeat while (imax => imin)                          ' repeat until found
     imid := (imin + imax) >> 1                         ' (imin+imax)/2
     compare := tch.stringcompare(0,imid)
     if compare > 0                                     ' search the upper half
       imin := imid + 1
     if compare < 0                                     ' search the lower half
       imax := imid - 1
     if compare == 0
       result := imid
       imax := 0                                        ' ends the routine
      

PUB Buttons | bu1x,bu1y,xval,yval,f1,f2,menuheight
   menuheight := 22                                     ' menu at the top of a form
   tch.SetOrientation(true)                             ' portrait view
   tch.ClearRam                                         ' file 0 and 1 reserved
   tch.SDBMPtoRam(string("form1.bmp"))                  ' file 2
   tch.DrawBMPRam(2,0,0)                                ' draw the background picture
   f1 := tch.Loadfont(string("MSans14W.ifn"))           ' file 3 black on white font  
   f2 := tch.Loadfont(string("MSans14.ifn"))            ' file 4 black on gray 14 point seems to be the same as 8.25 in vb.net ? why              
   tch.SDBMPtoRam(string("butn8430.bmp"))               ' file 5 a button 84x30 in size
   tch.stringdim(10)                                    ' file 6 is the strings
   tch.stringstore(0,string("Button1"))                 ' store string for the ok button     
   bu1x := 68
   bu1y := 37
   DrawButton(bu1x,bu1y+menuheight,0,5,f2)              ' button (fixed size at the moment)  
   Textbox(59,123+menuheight,59+118,123+16+menuheight)                        ' clear a text box. height = fontheight+1?

   ' now wait for touch
   tch.SelectSPIGroup                                   ' talk to the spi touchscreen
   repeat
      yval := tch.TouchYPercent                         ' decode yval 0-100%                
      xval := tch.TouchXPercent                         ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
        xval := (xval * 24) / 10                        ' scale to pixels as can measure from the picture in paintshop
        yval := (yval * 32) / 10                        ' scale to pixels
        if xval >68 and xval <(68+84) and yval>(37+menuheight) and yval<(30+37+menuheight)
          tch.SelectMemGroup                             ' display mode
          tch.setcurx(59+2)                                   
          tch.setcury(123+menuheight)                    ' y = y1 in textboxclear
          tch.TextT(f1,string("Hello World"))            ' draw text for the textbox
          tch.SelectSPIGroup                             ' talk to the spi touchscreen  
        

PUB StoreObjects | i,j,k
        tch.stringdim(100)      ' reserve space
        ' convert all " to ' as part of the preprocessor
        ' increment the number, start with 10
        ' leave the 'button1 as a comment
        ' leave string 0 to 9 free for general purpose
        ' common var databasestart is 10 and finish is whatever the preprocessor calculates
        ' preprocessor changes the new descriptor to something shorter and easier to search for
        'tch.stringstore(10,string("Me.Button1 = New System.Windows.Forms.Button"))     
        'tch.stringstore(11,string("Me.TextBox1 = New System.Windows.Forms.TextBox"))
        tch.stringstore(10,string("New Button Button1"))
        tch.stringstore(11,string("New Textbox Textbox1"))
        tch.stringstore(12,string("Me.SuspendLayout()"))     
        '
        'Button1
        '
        tch.stringstore(13,string("Me.Button1.Location = New System.Drawing.Point(68, 37)"))     
        tch.stringstore(14,string("Me.Button1.Name = 'Button1'"))     
        tch.stringstore(15,string("Me.Button1.Size = New System.Drawing.Size(84, 30)"))     
        tch.stringstore(16,string("Me.Button1.TabIndex = 0"))     
        tch.stringstore(17,string("Me.Button1.Text = 'Button1'"))     
        tch.stringstore(18,string("Me.Button1.UseVisualStyleBackColor = True"))     
        '
        'TextBox1
        '
        tch.stringstore(19,string("Me.TextBox1.Location = New System.Drawing.Point(59, 123)"))     
        tch.stringstore(20,string("Me.TextBox1.Name = 'TextBox1'"))     
        tch.stringstore(21,string("Me.TextBox1.Size = New System.Drawing.Size(118, 20)"))     
        tch.stringstore(22,string("Me.TextBox1.TabIndex = 1"))     
        '
        'Form1
        '
        tch.stringstore(23,string("Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)"))     
        tch.stringstore(24,string("Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font"))     
        tch.stringstore(25,string("Me.ClientSize = New System.Drawing.Size(232, 293)"))     
        tch.stringstore(26,string("Me.Controls.Add(Me.TextBox1)"))     
        tch.stringstore(27,string("Me.Controls.Add(Me.Button1)"))     
        tch.stringstore(28,string("Me.Name = 'Form1'"))     
        ' end storing the vb.net description of the objects
        DatabaseStart := 10     ' preprocessor puts this in
        DatabaseFinish := 28   
        'BubbleSort(DatabaseStart,DatabaseFinish)
        ' look for textboxes
        tch.stringstore(1,string("New Textbox"))
        repeat i from DatabaseStart to DatabaseFinish
          tch.stringleft(0,i,11)                                         ' move leftstring into 0 
          if tch.stringcompare(0,1) == 0
            ' found a textbox, so draw it
            tch.StringMidEnd(2,i,13) ' get the name of the object
            'tch.stringdebug(2) ' should print "Textbox1"
            tch.stringstore(3,string("Me.")) ' add me., search for me. plus the name of this object and store the length too
            tch.stringjoin(4,3,2) ' Me.Textbox1
            k := tch.stringlen(4) ' should be 8+3=11
            'tch.hex(k,8)
            repeat j from DatabaseStart to DatabaseFinish ' search for size descriptors for this textbox.
              

        tch.text(string("finished"))    
        

PUB TextBox(x1,y1,x2,y2)                           ' draw the outline of the box
    tch.ClearRectangle(x1,y1,x2,y2,tch.RGBtoWord(255,255,255))
    tch.Drawline(x1-1,y1-1,x2,y1-1,tch.RGBtoWord(64,64,64))        ' gray outline lines - extract values from paint shop pro
    tch.Drawline(x1-2,y1-2,x2+1,y1-2,tch.RGBtoWord(128,128,128))   ' horizontal upper light gray   
    tch.Drawline(x1-1,y1-1,x1-1,y2,tch.RGBtoWord(64,64,64))         ' vertical left gray
    tch.Drawline(x1-2,y1-2,x1-2,y2+1,tch.RGBtoWord(128,128,128))    ' vertical left light gray
    tch.Drawline(x2+2,y1-2,x2+2,y2+2,tch.RGBtoWord(255,255,255))    ' vertical right white
    tch.Drawline(x1-2,y2+2,x2+2,y2+2,tch.RGBtoWord(255,255,255))   ' horizontal lower white
                                           
PUB DrawButton(x,y,stringn,c1,f)                  ' draw a button box
   tch.DrawBMPRam(c1,x,y) 
   tch.setcurx(x + (84/2)-(tch.stringlen(stringn)*4 / 2))        ' centre, avg width 4 per char 84 could be a variable width passed to this routine
   tch.setcury(y + 8)
   tch.StringPrint(f,stringn)                               ' print
  